'Programm zur Erzeugung genauer Tne fr das Melodiespiel
'Hardware:  Drahtverbindungen:
'           PortD.0 mit Pieper
'           Taste auf GND an ext. INT
'           evtl. PortB mit 8 LEDs als Lichtorgel
'Funktion:  Timer 16 bit bestimmt die Tonhhe, Timer 8bit die Tonlnge
'-------------------------------------------------------------------------


'-------------------------------------------------------------------------
'-------------------------------------------------------------------------
'-------------------------------------------------------------------------
' Hardware: Takt intern oder Quarz 4-MHz, Piezzosummer an PortD.0

' Taste von PortD.2 nach Masse

' 16-Bit-Timer = Tonhhe, Warteschleife fr Tonlnge

' PortD.0 mit Piezzoschallwandler

'$regfile = "attiny2313.dat" je nach verwendetem C ndern
$regfile = "2313def.dat"
$crystal = 4000000

Dim Tonlaenge As Byte
Dim Taste1_gedrueckt As Bit
Dim Tonhoehe As Byte
Dim Timer1vorgabe As Word
Dim Sechzehntel As Byte
Dim Tonname As Byte


'****Musikalische Tempoeinstellung nach Metzel fr Viertel = Tempo
Const Tempo = 130                                           'diesen Wert ndern, um das Abspieltempo einzustellen
Const Tempo_gerechnet = 60000 /(4 * Tempo)

Declare Sub Ton()
Config Timer1 = Timer , Prescale = 1
'Hier geben wir der Definition einen schneren Namen
Piepser Alias Portd.0
On Timer1 Piepser_irq
On Int0 Taste_1_interrupt                                   'Interrupt fr Taste definieren
Config Int0 = Falling
Enable Int0
Ddrd = &B1110001
Portd = &B0001101                                           'Pull Ups aktivieren

'Hier werden die Timer aktiviert
Enable Interrupts
'Hier ist die Programmhauptschleife
Do
   If Taste1_gedrueckt = 1 Then
      Restore Melodie1
      Do
         Read Tonname
         Read Tonlaenge
         Call Ton()
         Stop Ac
      Loop Until Tonlaenge = 0
      Taste1_gedrueckt = 0
   End If

Marke:
Loop

'**********************************************************
'******************  Unterprogramme  **********************
Sub Ton()
   Select Case Tonname
' sehr tiefe Tne werden nicht bentigt und deshalb
' beginnen wir zur Speicherplatzoptimierung bei case 11
'Case 1: (((fehlt)))

'Case 2: (((fehlt)))

'Case 3: (((fehlt)))

'Case 4: (((fehlt)))

'Case 5: (((fehlt)))

'Case 6: (((fehlt)))

'Case 7: (((fehlt)))

'Case 8: (((fehlt)))

'Case 9: (((fehlt)))

'Case 10: (((fehlt)))
      Case 11 : Timer1vorgabe = 60434                       'G
      Case 12 : Timer1vorgabe = 60720                       'gis
      Case 13 : Timer1vorgabe = 60991                       'a
      Case 14 : Timer1vorgabe = 61246                       'ais
      Case 15 : Timer1vorgabe = 61486                       'h
      Case 16 : Timer1vorgabe = 61714                       'c
      Case 17 : Timer1vorgabe = 61928                       'cis
      Case 18 : Timer1vorgabe = 62131                       'd
      Case 19 : Timer1vorgabe = 62322                       'dis
      Case 20 : Timer1vorgabe = 62502                       'e
      Case 21 : Timer1vorgabe = 62673                       'f
      Case 22 : Timer1vorgabe = 62833                       'fis
      Case 23 : Timer1vorgabe = 62985                       'g
      Case 24 : Timer1vorgabe = 63128                       'gis
      Case 25 : Timer1vorgabe = 63263                       'a
      Case 26 : Timer1vorgabe = 63391                       'ais
      Case 27 : Timer1vorgabe = 63511                       'h
      Case 28 : Timer1vorgabe = 63625                       'c
      Case 29 : Timer1vorgabe = 63732                       'cis
      Case 30 : Timer1vorgabe = 63833                       'd
      Case 31 : Timer1vorgabe = 63929                       'dis
      Case 32 : Timer1vorgabe = 64019                       'e
'sehr hhe Tne werde nicht bentigt und deshalb weggelassen
'Case 33: (((fehlt)))

'Case 34: (((fehlt)))

'Case 35: (((fehlt)))

'Case 36: (((fehlt)))

'Case 37: (((fehlt)))

'Case 38: (((fehlt)))

'Case 39: (((fehlt)))

'Case 40: (((fehlt)))

'Case 41: (((fehlt)))

'Case 42: (((fehlt)))

'Case 43: (((fehlt)))

'Case 44: (((fehlt)))

'Case 45: (((fehlt)))

'Case 46: (((fehlt)))

'Case 47: (((fehlt)))

'Case 48: (((fehlt)))

'Case 49: (((fehlt)))
   End Select
   If Tonname <> 0 Then Enable Timer1
   For Sechzehntel = 1 To Tonlaenge
      Waitms Tempo_gerechnet                                'eine 16tel Note soll XXXms lang sein
   Next
   Disable Timer1
   Portb = 0
End Sub

'**********************************************************
'******************Interrupt routinen**********************

'*****Taste*****
Taste_1_interrupt:
  Disable Int0
   Taste1_gedrueckt = 1
  Enable Int0
Return


'*****Piepser******
Piepser_irq:
   Timer1 = Timer1vorgabe
   Toggle Piepser
Return


Melodie1:                                                   'Kleine Nachtmusik
Data 21 , 4 , 0 , 2 , 16 , 2 , 21 , 4 , 0 , 2 , 16 , 2 , 21 , 2 , 16 , 2
Data 21 , 2 , 25 , 2 , 28 , 4 , 0 , 4 , 26 , 4 , 0 , 2 , 23 , 2 , 26 , 4
Data 0 , 2 , 23 , 2 , 26 , 2 , 23 , 2 , 20 , 2 , 23 , 2 , 16 , 4 , 0 , 4
Data 21 , 2 , 0 , 2 , 21 , 6 , 25 , 2 , 23 , 2 , 21 , 1 , 0 , 1 , 21 , 2
Data 20 , 1 , 0 , 1 , 20 , 6,

Data 0 , 0